#Programmdatei wird geladen#
source("programme.R")


#Parameter definierem#
kappa <- 0.5
theta <- 0.06
sigma <- 0.15
para <- c(kappa,theta,sigma)


#Zeit festlegen#
time <- seq(from=0.0,by=1/12,length=1000)


#Anzahl der Simulationen#
n<-256

#Parameter fr SML-Kern festlegen#
m<-8
k<-256


#Datenmatrizen definieren#
mat_srp<-matrix(ncol=3,nrow=n,NA)
mat_euler<-matrix(ncol=3,nrow=n,NA)
mat_sml<-matrix(ncol=3,nrow=n,NA)
d<-matrix(ncol=3,nrow=n)


#Schleife fr die Wiederholte Schtzung#
for (i in 1:n)
   {    
   	#Zeitreihe mit der wahren bergangsdichte simulieren#
   	x <- simulatesrp(theta,kappa,theta,sigma,time)
	
	#Durchlauf ausgeben#
	print(i)
	
	#SRP-Schtzung mit Zeitmessung#
	d[i,1]<-system.time(erg1 <- minsrp(para,time,x))[3]
	
	#Euler-Schtzung mit Zeitmessung#
	d[i,2]<-system.time(erg2 <- mineulerll(para,time,x))[3]
	
	#SML-Schtzung mit Zeitmessung#
	d[i,3]<-system.time(erg3 <- mineulersml(para,x, 1/12, m, k, 1,3, 666))[3]
	
	#Aufnahme der ergebnisse in die Datenmatrix#
	mat_srp[i,]<-erg1$par
	mat_euler[i,]<-erg2$par
	mat_sml[i,]<-erg3$par
   }
   
#Berechnen dr Mittelwerte und Standardabweichungen#   
mean_ml_srp<-c(mean(mat_srp[,1]),mean(mat_srp[,2]),mean(mat_srp[,3]))
sd_ml_srp<-c(sd(mat_srp[,1]),sd(mat_srp[,2]),sd(mat_srp[,3]))

mean_ml_euler<-c(mean(mat_euler[,1]),mean(mat_euler[,2]),mean(mat_euler[,3]))
sd_ml_euler<-c(sd(mat_euler[,1]),sd(mat_euler[,2]),sd(mat_euler[,3]))

mean_ml_sml<-c(mean(mat_sml[,1]),mean(mat_sml[,2]),mean(mat_sml[,3]))
sd_ml_sml<-c(sd(mat_sml[,1]),sd(mat_sml[,2]),sd(mat_sml[,3]))



mat_euler_srp<-mat_srp-mat_euler
mean_euler_srp<-c(mean(mat_euler_srp[,1]),mean(mat_euler_srp[,2]),mean(mat_euler_srp[,3]))
sd_euler_srp<-c(sd(mat_euler_srp[,1]),sd(mat_euler_srp[,2]),sd(mat_euler_srp[,3]))

mat_sml_srp<-mat_srp-mat_sml
mean_sml_srp<-c(mean(mat_sml_srp[,1]),mean(mat_sml_srp[,2]),mean(mat_sml_srp[,3]))
sd_sml_srp<-c(sd(mat_sml_srp[,1]),sd(mat_sml_srp[,2]),sd(mat_sml_srp[,3]))
