#Daten einlesen; RV befindet sich in Spalte 3 daten[,3]
daten<-read.table("SundP500.txt")

#Daten einlesen beim Dateausschnitt
#daten<-read.table("SundP500ausschnitt.txt")


#Programme zur Schtzung und simlation einbinden
source("programme2.R")

#Bibliothek fr die Berechnung der deskriptiven Statistiken einbinden
library(fBasics)



#Zeit festlegen
time_king<-seq(from=0.0,by=1,length=length(daten[,3]))


#Likelihood maximieren (inklusive Berrechnung der Werte fr die Euler Schtzung
maxsrp <-minsrp(c(2,2,4),time_king,daten[,3])
maxeuler<-mineulerll(c(2,2,4),time_king,daten[,3])





#Desk. Statistiken, Quantile, ACF und PACF der Daten brechnen zum spteren Vergleich
schaetzer<-basicStats(daten[,3])
Qantile<-quantile(daten[,3],probs=c(.01,.025,.05,.1,.25,.5,.75,.9,.95,.975,.99))
Autocorr<-acf(daten[,3],lag.max=15,plot=FALSE)
PAutocorr<-pacf(daten[,3],lag.max=15,plot=FALSE)
schaetzer1<-c(t(schaetzer),Qantile)


#Lnge der Simlation festlegen; Burn In 10000
t<-schaetzer[1,]+10000

#Zeit festlegen
time<-seq(from=0.0,by=1,length=t)

#Anzah der Simulation festlegen
n<-25000

#Datenmatrizen Definieren
mat_srp<-matrix(ncol=27,nrow=n,NA)
Autoc<-matrix(ncol=16,nrow=n,NA)
PAutoc<-matrix(ncol=15,nrow=n,NA)

#Parameter fr Schtzung festlegen
kappa <- maxsrp$par[1]
theta <- maxsrp$par[2]
sigma <- maxsrp$par[3]



#Simulationsschleife
for (i in 1:n)
   {
	#Neue Daten simulieren mit Startwert wie in den realen Daten
	a<-simulatesrp(daten[1,3],kappa,theta,sigma,time)
	#Burn In abschneiden
        a1<-a[10001:length(a)]
        #Desk. Statistiken, Quantile, ACF und PACF der Simulation in Datenmatrix sichern
        Qant<-quantile(a1,probs=c(.01,.025,.05,.1,.25,.5,.75,.9,.95,.975,.99))
	Autoc[i,]<-acf(a1,lag.max=15,plot=FALSE)$acf
        PAutoc[i,]<-pacf(a1,lag.max=15,plot=FALSE)$acf
	mat_srp[i,]<-c(t(basicStats(a1)),Qant)
	#Durchlauf ausgeben
	print(i)
   }

